{
-----------------------------------------------------------------
Code generated with MAS Component Wizard, 2000-2003 MASoft
-----------------------------------------------------------------

Component Name: TmFileList
        Author: MASoft, Mats Asplund
 Creation Date: 2003-12-08
       Version: 1.0
   Description: A TStringGrid descendant with progressbar in grid.
        E-mail: mdp@telia.com
       Website: http://hem.passagen.se/matasp
  Legal Issues: All rigths reserved 2003 by MASoft, Mats Asplund


Usage:
  This software is provided 'as-is', without any express or
  implied warranty.  In no event will the author be held liable
  for any  damages arising from the use of this software.

  Permission is granted to anyone to use this software for any
  purpose, including commercial applications, and to alter it
  and redistribute it freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented,
     you must not claim that you wrote the original software.
     If you use this software in a product, an acknowledgment
     in the product documentation would be appreciated but is
     not required.

  2. Altered source versions must be plainly marked as such, and
     must not be misrepresented as being the original software.

  3. This notice may not be removed or altered from any source
     distribution.

  4. If you decide to use this software in any of your applications.
     Send me an EMail and tell me about it.

Quick Reference:
  TmFileList inherits from TStringGrid

  Key-Methods:
    function Progress(Index, Count,       If Index = -1 a new row will be added,
      CountTotal, Speed: integer; Title,  else row will be updated.
      Status): boolean;                   Returns true if row exists.
                                          Time cell will be set to 00:00:00 when
                                          a row is inserted, a new time value will
                                          automatically be calculated on update.
---------------------------------------------------------------
}

unit mFileList;

interface

uses
  Windows, Messages, SysUtils, Classes, Grids, Controls, ExtCtrls, Dialogs;

type
  TmFileList = class(TStringGrid)
  private
    fProgress: TStringList;
    fStart: Boolean;
    fAbout: string;
    fPImages: array of TImage;
    fRTimes: array of cardinal;
    fTimer: TTimer;
    fRTime: cardinal;
    procedure FileListDrawCell(Sender: TObject; ACol, ARow: integer;
      Rect: TRect; State: TGridDrawState);
    procedure OnTimer(Sender: TObject);
    procedure SetAbout(Value: string);
  protected
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function Progress(Index, Count, CountTotal: integer; Title, Speed,
      Status: string): boolean;
    procedure InitList;
  published
    property About: string read fAbout write SetAbout;
  end;

procedure Register;

const
  Pics: array[0..11] of PChar = ('PROG0', 'PROG1', 'PROG2', 'PROG3', 'PROG4',
    'PROG5', 'PROG6', 'PROG7', 'PROG8', 'PROG9', 'PROG10', 'STOP');

implementation
{$R progress_pics.res}

procedure Register;
begin
  RegisterComponents('MASoft', [TmFileList]);
end;

function GetHourMinSec(Seconds: cardinal): string;
var
  Hour, Min, Sec: string;
  Tmp, Tmp2: integer;
begin
  Tmp:= Seconds div 3600;
  if Tmp < 10 then
    Hour:= '0' + IntToStr(Tmp)
  else
    Hour:= IntToStr(Tmp);
  Tmp:= Seconds mod 3600;
  Tmp2:= Tmp;
  Tmp:= Tmp div 60;
  if Tmp < 10 then
    Min:= '0' + IntToStr(Tmp)
  else
    Min:= IntToStr(Tmp);
  Tmp:= Tmp2 mod 60;
  if Tmp < 10 then
    Sec:= '0' + IntToStr(Tmp)
  else
    Sec:= IntToStr(Tmp);
  Result:= Hour + ':' + Min + ':' + Sec;
end;

constructor TmFileList.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  fProgress:= TStringList.Create;
  fRTime:= 0;
  fTimer:= TTimer.Create(nil);
  fTimer.Interval:= 1000;
  fTimer.OnTimer:= OnTimer;
  fTimer.Enabled:= true;
  InitList;
  fAbout:= 'Version 1.0, 2003 MASoft';
end;

destructor TmFileList.Destroy;
begin
  inherited Destroy;
  fProgress.Free;
  SetLength(fPImages, 0);
end;

procedure TmFileList.FileListDrawCell(Sender: TObject; ACol, ARow: integer;
  Rect: TRect; State: TGridDrawState);
begin
  if (ARow > 0) and (ACol = 3) and (fProgress.Count > 0) then
    Canvas.Draw(Rect.Left + 1, Rect.Top + 3, fPImages[ARow - 1].Picture.Bitmap);
end;

procedure TmFileList.InitList;
var
  n: integer;
begin
  fStart:= true;
  SetLength(fPImages, 0);
  SetLength(fRTimes, 0);
  fProgress.Clear;

  Width:= 575;
  Height:= 153;
  ColCount:= 6;
  DefaultRowHeight:= 16;
  FixedCols:= 0;
  RowCount:= 2;
  Options:= [goVertLine, goHorzLine, goRangeSelect, goColSizing, goRowSelect,
    goThumbTracking];
  OnDrawCell:= FileListDrawCell;
  ColWidths[0]:= 160;
  ColWidths[1]:= 63;
  ColWidths[2]:= 111;
  ColWidths[3]:= 75;
  ColWidths[4]:= 85;
  ColWidths[5]:= 70;
  Cells[0, 0]:= 'Title';
  Cells[1, 0]:= 'Speed';
  Cells[2, 0]:= 'Downloaded/Total';
  Cells[3, 0]:= 'Progress';
  Cells[4, 0]:= 'Status';
  Cells[5, 0]:= 'Time';
  for n:= 0 to 5 do
    Cells[n, 1]:= '';
end;

procedure TmFileList.OnTimer(Sender: TObject);
begin
  Inc(fRTime);
end;

function TmFileList.Progress(Index, Count, CountTotal: integer; Title, Speed,
  Status: string): boolean;
var
  Progr: integer;
  Offset: integer;
begin
  Result:= false;
  if Index < RowCount - 1 then
  begin
    Result:= true;
    if CountTotal = 0 then
      Progr:= 0
    else
      Progr:= (10 * Count) div CountTotal;

    if Index = -1 then
    begin
      fProgress.Add(IntToStr(Progr));
      SetLength(fPImages, Length(fPImages) + 1);
      SetLength(fRTimes, Length(fRTimes) + 1);
      fPimages[Length(fPImages) - 1]:= TImage.Create(Self);
      fPImages[Length(fPImages) - 1].Picture.Bitmap.Handle:=
        LoadBitmap(HInstance, Pics[Progr]);
      fRTimes[Length(fRTimes) - 1]:= fRTime;
      if not fStart then
        RowCount:= RowCount + 1;
    end
    else
    begin
      fProgress[Index]:= IntToStr(Progr);
      fPImages[Index].Picture.Bitmap.Handle:=
        LoadBitmap(HInstance, Pics[Progr]);
      if (Status = 'File not found') or (Status = 'Busy. Try later.') or
        (Status = 'Interrupted') then
        fPImages[Index].Picture.Bitmap.Handle:=
          LoadBitmap(HInstance, Pics[11]);
    end;

    if Index = -1 then
    begin
      Offset:= RowCount - 1;
      Cells[5, Offset]:= GetHourMinSec(0);
    end
    else
    begin
      Offset:= Index + 1;
      Cells[5, Offset]:= GetHourMinSec(fRTime - fRTimes[Index]);
    end;
    if Title <> '' then
      Cells[0, Offset]:= Title;
    if Speed <> '' then
      Cells[1, Offset]:= Speed + ' kb/s';
    if (Count <> -1) and (CountTotal <> -1) then
      Cells[2, Offset]:= IntToStr(Count) + ' of ' + IntToStr(CountTotal) + ' kb';
    if Status <> '' then
      Cells[4, Offset]:= Status;

    fStart:= false;
    Invalidate;
  end;
end;

procedure TmFileList.SetAbout(Value: string);
begin
  Exit;
end;

end.

